import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import {OverviewComponent} from './overview/overview.component';
import {SelectGameComponent} from './select-game/select-game.component';
import {ErrorComponent} from './error/error.component';
import {GameComponent} from './game/game.component';
import {GuesserComponent} from './guesser/guesser.component';
import {ImpressumComponent} from './impressum/impressum.component';

const routes: Routes = [
  {
    path: 'error',
    component: ErrorComponent,
  },
  {
    path: 'impressum',
    component: ImpressumComponent,
  },
  {
    path: ':sessionName',
    component: OverviewComponent,
  },
  {
    path: ':sessionName/:team',
    component: OverviewComponent,
  },
  {
    path: ':sessionName/:team/watchdog',
    component: GameComponent,
  },
  {
    path: ':sessionName/:team/explainer',
    component: GameComponent,
  },
  {
    path: ':sessionName/:team/guesser',
    component: GuesserComponent,
  },
  {
    path: '',
    component: SelectGameComponent,
  },
  {
    path: '**',
    component: ErrorComponent,
  },
];

@NgModule({
  imports: [RouterModule.forRoot(routes, {
    useHash: true,
    enableTracing: false,
    relativeLinkResolution: 'legacy'
  })],
  exports: [RouterModule]
})
export class AppRoutingModule { }
