import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { environment } from '../../environments/environment';

@Injectable({
  providedIn: 'root'
})
export class TabuMiddlewareService {

  constructor(private http: HttpClient) {
  }

  private async request(method: string, url: string, data?: any): Promise<any> {

    const result = this.http.request(method, url, {
      body: data,
      responseType: 'json',
      observe: 'body',
    });
    return new Promise((resolve, reject) => {
      result.subscribe(resolve, reject);
    });
  }

  getSessions(): Promise<any> {
    return this.request('GET', `${environment.tabuMiddlewareURL}Session`);
  }

  isSession(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}isSession`, req);
  }

  addSession(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}addSession`, req);
  }

  getGamestatus(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}getGamestatus`, req);
  }

  getS2C(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}getS2C`, req);
  }

  getActiveCard(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}getActiveCard`, req);
  }

  addPoint(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}addPoint`, req);
  }

  removePoint(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}removePoint`, req);
  }

  newGame(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}newGame`, req);
  }

  newRound(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}newRound`, req);
  }

  endRound(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}endRound`, req);
  }

  getCard(req: any): Promise<any> {
    return this.request('POST', `${environment.tabuMiddlewareURL}getCard`, req);
  }
}
