import {io} from 'socket.io-client';
import {Observable} from 'rxjs';
import {environment} from '../../environments/environment';

export class SocketDataService {

  private socket: any;
  isConnected = false;
  sessionName = '';

  constructor() {
  }

  connect(sessionName: string): void {
    console.log('NEW CONNECTION');
    this.sessionName = sessionName;
    if (!this.isConnected) {
      this.socket = io(environment.tabuServerURL);
      this.isConnected = true;
    }
  }

  disconect(): void {
    if (this.isConnected) {
      this.socket.disconnect();
      this.isConnected = false;
    }
  }

  getNewGame(sessionName: string): Observable<any> {
    if (!this.isConnected) {
      this.connect(sessionName);
    }
    this.sessionName = sessionName;
    return new Observable(observer => {
      this.socket.on(this.sessionName + ':newGame', (res: any) => {
        observer.next(res);
      });
    });
  }

  getNewCard(sessionName: string): Observable<any> {
    if (!this.isConnected) {
      this.connect(sessionName);
    }
    this.sessionName = sessionName;
    return new Observable(observer => {
      this.socket.on(this.sessionName + ':newCard', (res: any) => {
        observer.next(res);
      });
    });
  }

  getNewRound(sessionName: string): Observable<any> {
    if (!this.isConnected) {
      this.connect(sessionName);
    }
    this.sessionName = sessionName;
    return new Observable(observer => {
      this.socket.on(this.sessionName + ':newRound', (res: any) => {
        observer.next(res);
      });
    });
  }

  getEndRound(sessionName: string): Observable<any> {
    if (!this.isConnected) {
      this.connect(sessionName);
    }
    this.sessionName = sessionName;
    return new Observable(observer => {
      this.socket.on(this.sessionName + ':endRound', (res: any) => {
        observer.next(res);
      });
    });
  }
}
